#include "atom.h"
#include "nucleon.h"
#include "controlrod.h"

using namespace GraphicsLib;
using namespace std;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

controlrod::controlrod(float radius, float length, Point3 pos)
{
	centrePos = pos;
	Radius = radius;
	Length = length;

	rodCorners[0].x = centrePos.x-(Radius/2);
	rodCorners[0].y = centrePos.y+(Length);
	rodCorners[0].z = centrePos.z-(Radius/2);

	rodCorners[1].x = centrePos.x-(Radius/2);
	rodCorners[1].y = centrePos.y+(Length);
	rodCorners[1].z = centrePos.z-(Radius/2);

	rodCorners[2].x = centrePos.x-(Radius/2);
	rodCorners[2].y = centrePos.y+(Length);
	rodCorners[2].z = centrePos.z-(Radius/2);

	rodCorners[3].x = centrePos.x-(Radius/2);
	rodCorners[3].y = centrePos.y+(Length);
	rodCorners[3].z = centrePos.z-(Radius/2);

	rodCorners[4].x = centrePos.x-(Radius/2);
	rodCorners[4].y = centrePos.y+(Length);
	rodCorners[4].z = centrePos.z-(Radius/2);

	rodCorners[5].x = centrePos.x-(Radius/2);
	rodCorners[5].y = centrePos.y+(Length);
	rodCorners[5].z = centrePos.z-(Radius/2);

	rodCorners[6].x = centrePos.x-(Radius/2);
	rodCorners[6].y = centrePos.y+(Length);
	rodCorners[6].z = centrePos.z-(Radius/2);

	rodCorners[7].x = centrePos.x-(Radius/2);
	rodCorners[7].y = centrePos.y+(Length);
	rodCorners[7].z = centrePos.z-(Radius/2);

	rodNormals[0].set(0.0f,1.0f,0.0f);
	rodNormals[1].set(0.0f,-1.0f,0.0f);
	rodNormals[2].set(1.0f,0.0f,0.0f);
	rodNormals[3].set(-1.0f,0.0f,0.0f);
	rodNormals[4].set(0.0f,0.0f,1.0f);
	rodNormals[5].set(0.0f,0.0f,-1.0f);
}

//------------------------------------------------------------------------------

controlrod::~controlrod()
{
// nothing to do here
}

//------------------------------------------------------------------------------

void controlrod::Draw()
{
	glPushMatrix();
		//glLoadIdentity();
		glTranslatef(centrePos.x,centrePos.y,centrePos.z);
		glRotated(90,1.0,0.0,0.0);
		glPushMatrix();
			GLUquadricObj *pipe;
			pipe = gluNewQuadric();
			glColor3f(0.0,1.0,1.0);
			gluCylinder(pipe,Radius/2,Radius/2,Length,10,5);


		glPopMatrix();
	glPopMatrix();
}

//------------------------------------------------------------------------------

void controlrod::insert()
{
	//rods are being inserted from the top of the volume
	centrePos.y -= 0.5;
}

//------------------------------------------------------------------------------

void controlrod::remove()
{
 	centrePos.y += 0.5;
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
