//create a box which can contain the particle system.
//the box is formed of 6 planes.

#include "shellBox.h"

using namespace GraphicsLib;
using namespace std;

static const int Faces[6][4]=
{
	{0,3,7,4},{0,1,5,4},{1,2,6,5},{2,3,7,6},{0,1,2,3},{4,5,6,7}
};

shellBox::shellBox(float width,float height,float depth, Point3 boxCentre)
{
 	BOXCentre = boxCentre;
	Width = width;
	Height = height;
	Depth = depth;

	shellCorners[0].x = BOXCentre.x-(Width/2.0f);
	shellCorners[0].y = BOXCentre.y+(Height/2.0f);
	shellCorners[0].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[1].x = BOXCentre.x-(Width/2.0f);
	shellCorners[1].y = BOXCentre.y+(Height/2.0f);
	shellCorners[1].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[2].x = BOXCentre.x-(Width/2.0f);
	shellCorners[2].y = BOXCentre.y+(Height/2.0f);
	shellCorners[2].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[3].x = BOXCentre.x-(Width/2.0f);
	shellCorners[3].y = BOXCentre.y+(Height/2.0f);
	shellCorners[3].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[4].x = BOXCentre.x-(Width/2.0f);
	shellCorners[4].y = BOXCentre.y+(Height/2.0f);
	shellCorners[4].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[5].x = BOXCentre.x-(Width/2.0f);
	shellCorners[5].y = BOXCentre.y+(Height/2.0f);
	shellCorners[5].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[6].x = BOXCentre.x-(Width/2.0f);
	shellCorners[6].y = BOXCentre.y+(Height/2.0f);
	shellCorners[6].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[7].x = BOXCentre.x-(Width/2.0f);
	shellCorners[7].y = BOXCentre.y+(Height/2.0f);
	shellCorners[7].z = BOXCentre.z-(Depth/2.0f);

	shellNormals[0].set(0.0f,1.0f,0.0f);
	shellNormals[1].set(0.0f,-1.0f,0.0f);
	shellNormals[2].set(1.0f,0.0f,0.0f);
	shellNormals[3].set(-1.0f,0.0f,0.0f);
	shellNormals[4].set(0.0f,0.0f,1.0f);
	shellNormals[5].set(0.0f,0.0f,-1.0f);

}

shellBox::~shellBox()
{

}

void shellBox::set(float width,float height,float depth, Point3 boxCentre)
{
 	BOXCentre = boxCentre;
	Width = width;
	Height = height;
	Depth = depth;

	shellCorners[0].x = BOXCentre.x-(Width/2.0f);
	shellCorners[0].y = BOXCentre.y+(Height/2.0f);
	shellCorners[0].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[1].x = BOXCentre.x-(Width/2.0f);
	shellCorners[1].y = BOXCentre.y+(Height/2.0f);
	shellCorners[1].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[2].x = BOXCentre.x-(Width/2.0f);
	shellCorners[2].y = BOXCentre.y+(Height/2.0f);
	shellCorners[2].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[3].x = BOXCentre.x-(Width/2.0f);
	shellCorners[3].y = BOXCentre.y+(Height/2.0f);
	shellCorners[3].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[4].x = BOXCentre.x-(Width/2.0f);
	shellCorners[4].y = BOXCentre.y+(Height/2.0f);
	shellCorners[4].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[5].x = BOXCentre.x-(Width/2.0f);
	shellCorners[5].y = BOXCentre.y+(Height/2.0f);
	shellCorners[5].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[6].x = BOXCentre.x-(Width/2.0f);
	shellCorners[6].y = BOXCentre.y+(Height/2.0f);
	shellCorners[6].z = BOXCentre.z-(Depth/2.0f);

	shellCorners[7].x = BOXCentre.x-(Width/2.0f);
	shellCorners[7].y = BOXCentre.y+(Height/2.0f);
	shellCorners[7].z = BOXCentre.z-(Depth/2.0f);

	shellNormals[0].set(0.0f,1.0f,0.0f);
	shellNormals[1].set(0.0f,1.0f,0.0f);
	shellNormals[2].set(0.0f,1.0f,0.0f);
	shellNormals[3].set(0.0f,1.0f,0.0f);
	shellNormals[4].set(0.0f,1.0f,0.0f);
	shellNormals[5].set(0.0f,1.0f,0.0f);
}

void shellBox::Draw(void)
{

glColor3f(1.0f,1.0f,1.0f);
glPushMatrix();
//loop through all the faces
/*for(int i=0; i<6; i++)
	{
	//and draw each of the vertices
        glBegin(GL_LINE_LOOP);
	//now loop throught for each of the verts and draw
    for(int x=0; x<4; x++)
    	{
        shellCorners[Faces[i][x]].Vertex(); // Vertex is a method of Point class to call glVertex
	}
	glEnd();
	}*/
	glutWireCube(Width);
glPopMatrix();
}



